
; Routinen fuer HWE fuer CPD6




; *** COPY_RAM_TO_SECTOR ***
;
; Aufruf: COPY_RAM_TO_SECTOR
;
; Funktion:
; 
;
; Uebergabeparameter: HL = RAM-Adresse an die der Sektor kopiert werden soll
;                     C  = Auswahl der RAM-Page 
; Rueckgabeparameter: keine
;
COPY_RAM_TO_SECTOR:

		LD	A,IORQ_RAM2ARR
		OUT	(AUSGANG),A

		LD	A,C
		OUT	(AUSGANG),A

		JP	(HL)

		NOP
		NOP




; *** COPY_SECTOR_TO_RAM ***
;
; Aufruf: COPY_SECTOR_TO_RAM
;
; Funktion:
; 
;
; Uebergabeparameter: HL = RAM-Adresse an die der Sektor kopiert werden soll
;                     C  = Auswahl der RAM-Page 
; Rueckgabeparameter: keine
;
COPY_SECTOR_TO_RAM:

		LD	A,IORQ_ARR2RAM
		OUT	(AUSGANG),A

		LD	A,C
		OUT	(AUSGANG),A

		JP	(HL)

		NOP
		NOP




; *** STD_an_uC ***
;
; Aufruf: STD_an_uC
;
; Funktion:
; Die Werte fuer Sektor, Spur und Laufwerksnummer (SECTOR, TRACK, DISK-NO) werden
; an den Mikrocontroller gesendet und dort abgespeichert
;
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
;
STD_an_uC:

		LD	A,IORQ_STD2UC
		OUT	(AUSGANG),A

		LD	A,(SECTOR)
		OUT	(AUSGANG),A

		LD	A,(TRACK)
		OUT	(AUSGANG),A

		LD	A,(TRACK+1)
		OUT	(AUSGANG),A

		LD	A,(DISKNO)
		OUT	(AUSGANG),A


		RET




; *** COPY_BDOS_TO_RAM ***
;
; Aufruf: COPY_BDOS_TO_RAM
;
; Funktion:
; Dies ist die Service-Routine fuer das Kopieren des BDOS in den RAM.
; Das eigentliche Kopieren wird durch den Mikrocontroller nach dem
; Aufruf dieser Funktion vorgenommen. Das Kopieren beginnt an der Adresse BDOSBASE.
;
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
;
COPY_BDOS_TO_RAM:

		LD	HL,BDOSBASE

		LD	A,IORQ_BDOS2RAM
		OUT	(AUSGANG),A

		JP	(HL)

		NOP
		NOP




; *** COPY_CCP_TO_RAM ***
;
; Aufruf: COPY_CCP_TO_RAM
;
; Funktion:
; Dies ist die Service-Routine fuer das Kopieren des CCP in den RAM.
; Das eigentliche Kopieren wird durch den Mikrocontroller nach dem
; Aufruf dieser Funktion vorgenommen. Das Kopieren beginnt an der Adresse CCPBASE.
;
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
;
COPY_CCP_TO_RAM:

		LD	HL,CCPBASE

		LD	A,IORQ_CCP2RAM
		OUT	(AUSGANG),A

		JP	(HL)

		NOP
		NOP




; *** COPY_DISK_TO_RAM ***
;
; Aufruf: COPY_DISK_TO_RAM
;
; Funktion:
; Dies ist die Service-Routine fuer das Kopieren der Anfangsdateien auf die RAM-Floppy.
; Das eigentliche Kopieren wird durch den Mikrocontroller nach dem
; Aufruf dieser Funktion vorgenommen. Das Kopieren beginnt an der Adresse 0.
;
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
;
COPY_DISK_TO_RAM:

		LD	HL,0

		LD	A,IORQ_DISK2RAM
		OUT	(AUSGANG),A

		JP	(HL)

		NOP
		NOP







; *** LADE_ZEIT ***
;
; Aufruf: LADE_ZEIT
;
; Funktion:
; Es wird der Zeitstempel vom PC geholt und dem CP/M uebergeben
;
; Uebergabeparameter: HL = Adresse des SCB-TIME
; Rueckgabeparameter: keine
;
LADE_ZEIT:

		LD	A,IORQ_TIME
		OUT	(AUSGANG),A

		IN	A,(AUSGANG)
		LD	(HL),A
		INC	HL

		IN	A,(AUSGANG)
		LD	(HL),A
		INC	HL

		IN	A,(AUSGANG)
		LD	(HL),A
		INC	HL

		IN	A,(AUSGANG)
		LD	(HL),A
		INC	HL

		IN	A,(AUSGANG)
		LD	(HL),A
		INC	HL


		; Ruecksprung
		;
		RET










