


; **********************************************************
;  Monitor
; **********************************************************






; Funktion: WordToCONOUT
;
; Aufruf: WordToCONOUT
; Uebergabeparameter: Register HL - Wordwert
; Rueckgabeparameter: keine
; 
WordToCONOUT:
		CALL	WordToHex		
		;
		PUSH	DE
		PUSH	BC
		;
		LD	C,B
		CALL	CONOUT
		;
		POP	BC
		;
		CALL	CONOUT
		;
		POP	DE
		PUSH	DE
		;
		LD	C,D
		CALL	CONOUT
		;
		POP	DE
		;
		LD	C,E
		CALL	CONOUT
		;
		LD	C,'H'
		CALL	CONOUT
		;
		RET





; Funktion: ByteToCONOUT
;
; Aufruf: ByteToCONOUT
; Uebergabeparameter: Register A = Bytewert
; Rueckgabeparameter: keine
; 
ByteToCONOUT:
		CALL	ByteToHex
		PUSH	BC
		;
		LD	C,B
		CALL	CONOUT
		;
		POP	BC
		CALL	CONOUT
		;
		LD	C,'H'
		CALL	CONOUT
		;
		RET
		



; Funktion: WordToHex
;
; Aufruf: WordToHex
; Uebergabeparameter: Register HL = Wordwert
; Rueckgabeparameter: Register BC und DE - ASCII-Zeichen des Wordwertes
; 
WordToHex:
		LD	A,H
		PUSH	HL
		;
		CALL	ByteToHex
		;
		POP	HL
		PUSH	BC
		;
		LD	A,L
		;
		CALL	ByteToHex
		;
		LD	D,B
		LD	E,C
		POP	BC
		;
		RET







; Funktion: ByteToHex
;
; Aufruf: ByteToHex
; Uebergabeparameter: Register A = Bytewert
; Rueckgabeparameter: Register BC - B = HWT, C = LWT
; 
ByteToHex:
		PUSH	AF
		AND	00FH
		;
		CALL	ByteToHex_A
		LD	C,A
		;
		POP	AF
		SRL	A
		SRL	A
		SRL	A
		SRL	A
		;
		CALL	ByteToHex_A
		LD	B,A
		;
		RET


ByteToHex_A:	ADD	A,'0'		; Zahl '0'
		CP	'9'+1		; '9'+1 -> 0..9 = Cyrry , A..F = not Curry
		RET	C
		;
		ADD	A,07		; 65D ('A') - 48D ('0') = 17D -> Differenz zw. '0' und 'A'
		;
		RET








; Funktion: 1 Sektor ab Adresse HL anzeigen (an CONOUT) 
;
; Aufruf: SEKToCONOUT
; Uebergabeparameter: Register HL = Anfangsadresse der Bytewerte
; Rueckgabeparameter: Register HL = Ziel-Adresse fuer weitere Bytewerte
; 
SEKToCONOUT:
		LD	A,8
		;
SEKToCONOUT_1:
		PUSH	AF
		CALL	By16ToCONOUT
		;
		POP	AF
		;
		DEC	A
		JR	NZ,SEKToCONOUT_1
		;
		RET




; Funktion: 16 Byts ab Adresse HL anzeigen (an CONOUT) 
;
; Aufruf: By16ToCONOUT
; Uebergabeparameter: Register HL = Anfangsadresse der Bytewerte
; Rueckgabeparameter: Register HL = Ziel-Adresse fuer weitere Bytewerte
; 
By16ToCONOUT:
		PUSH	HL
		;
		CALL	WordToCONOUT
		;
		LD	C,','
		CALL	CONOUT
		;
		POP	HL
		LD	A,16
		;
By16ToCONOUT_1:
		PUSH	AF
		;
		LD	A,(HL)
		INC	HL
		PUSH	HL
		;
		CALL	ByteToCONOUT
		;
		LD	C,','
		CALL	CONOUT
		;
		POP	HL	
		POP	AF
		;
		DEC	A
		JR	NZ,By16ToCONOUT_1
		;
		PUSH	HL
		;
		CALL	AUS_CRLF	; Abschluss der Eingabezeile
		;
		POP	HL
		;
		RET



ZK_Sektor:
		DB	0DH,0AH,"Sektor=",0

ZK_Spur:
		DB	"  Spur=",0

ZK_LW:
		DB	"  Laufwerk=",0


; Funktion: Sektor, Spur und Laufwerk (STD) anzeigen (an CONOUT) 
;
; Aufruf: STD_To_CONOUT
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
; 
STD_To_CONOUT:
		LD	HL,ZK_Sektor	; ZK_Sektor
		CALL	AUS_ZK
		;
		LD	A,(SECTOR)
		CALL	ByteToCONOUT
		;

		LD	HL,ZK_Spur	; ZK_Spur
		CALL	AUS_ZK
		;
		LD	HL,(TRACK)
		CALL	WordToCONOUT
		;
		LD	HL,ZK_LW	; ZK_LW
		CALL	AUS_ZK
		;
		LD	A,(DISKNO)
		CALL	ByteToCONOUT
		;
		CALL	AUS_CRLF	; Abschluss der Eingabezeile
		;
		RET




ZK_FORMAT:
		DB	0DH,"Spur:",0

ZK_FORMAT2:
		DB	" wurde formatiert ...",0



; Funktion: Ausgabe der gerade formatierten Spur 
;
; Aufruf: FORMAT_To_CONOUT
; Uebergabeparameter: keine
; Rueckgabeparameter: keine
; 
FORMAT_To_CONOUT:

		LD	HL,ZK_FORMAT
		CALL	AUS_ZK
		;
		LD	HL,(TRACK)
		CALL	WordToCONOUT
		;
		LD	HL,ZK_FORMAT2
		CALL	AUS_ZK
		;
		RET




ZK_ZEIT:
		DB	0DH,0AH,"Zeit:",0



; Funktion: Ausgabe der gerade formatierten Spur 
;
; Aufruf: ZEIT_To_CONOUT
; Uebergabeparameter: Register HL = Anfangsadresse der Bytewerte
; Rueckgabeparameter: keine
; 
ZEIT_To_CONOUT:

		PUSH	HL

		LD	HL,ZK_ZEIT
		CALL	AUS_ZK
		;
		POP	HL

		LD	A,5
		;
ZEIT_To_CONOUT_1:
		PUSH	AF
		;
		LD	A,(HL)
		INC	HL
		PUSH	HL
		;
		CALL	ByteToCONOUT
		;
		POP	HL	
		POP	AF
		;
		DEC	A
		JR	NZ,ZEIT_To_CONOUT_1
		;
		CALL	AUS_CRLF	; Abschluss der Eingabezeile

		;
		RET











